# coding: utf-8

"""
    Project Service API

    Project Service exposes a REST API, providing access to operations with projects Example: 1. `$orderby` - Sorting criteria in the format: property (asc | desc). Default sort order is ascending.     ```/project-service/api/projects?$orderby=name%20desc``` 2. `$top` -  limits the requested number of resources.     ```/project-service/api/projects?$top=10``` 3. `$skip` -  client can skip a given number of resources.      ```/project-service/api/projects?$skip=2``` 4. `$top` & `$skip` - used in conjunction helps in pagination of resources        ```/project-service/api/projects?$top=10&$skip=2``` 5. `$filter` -  returns a subset of resources that satisfy the given predicate expression.     ```/project-service/api/projects?$filter=startswith(name, 'Test')```  # noqa: E501

    OpenAPI spec version: 2020-08-10
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RoleAssignment(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'org_id': 'str',
        'principal_id': 'str',
        'principal_type': 'str',
        'project_id': 'str',
        'role_id': 'str'
    }

    attribute_map = {
        'org_id': 'orgId',
        'principal_id': 'principalId',
        'principal_type': 'principalType',
        'project_id': 'projectId',
        'role_id': 'roleId'
    }

    def __init__(self, org_id=None, principal_id=None, principal_type=None, project_id=None, role_id=None):  # noqa: E501
        """RoleAssignment - a model defined in Swagger"""  # noqa: E501
        self._org_id = None
        self._principal_id = None
        self._principal_type = None
        self._project_id = None
        self._role_id = None
        self.discriminator = None
        if org_id is not None:
            self.org_id = org_id
        self.principal_id = principal_id
        if principal_type is not None:
            self.principal_type = principal_type
        if project_id is not None:
            self.project_id = project_id
        self.role_id = role_id

    @property
    def org_id(self):
        """Gets the org_id of this RoleAssignment.  # noqa: E501

        The id of the org this role belongs to  # noqa: E501

        :return: The org_id of this RoleAssignment.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this RoleAssignment.

        The id of the org this role belongs to  # noqa: E501

        :param org_id: The org_id of this RoleAssignment.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def principal_id(self):
        """Gets the principal_id of this RoleAssignment.  # noqa: E501

        The id of the principal this role assignment is applicable for  # noqa: E501

        :return: The principal_id of this RoleAssignment.  # noqa: E501
        :rtype: str
        """
        return self._principal_id

    @principal_id.setter
    def principal_id(self, principal_id):
        """Sets the principal_id of this RoleAssignment.

        The id of the principal this role assignment is applicable for  # noqa: E501

        :param principal_id: The principal_id of this RoleAssignment.  # noqa: E501
        :type: str
        """
        if principal_id is None:
            raise ValueError("Invalid value for `principal_id`, must not be `None`")  # noqa: E501

        self._principal_id = principal_id

    @property
    def principal_type(self):
        """Gets the principal_type of this RoleAssignment.  # noqa: E501

        The principal type (user/group)  # noqa: E501

        :return: The principal_type of this RoleAssignment.  # noqa: E501
        :rtype: str
        """
        return self._principal_type

    @principal_type.setter
    def principal_type(self, principal_type):
        """Sets the principal_type of this RoleAssignment.

        The principal type (user/group)  # noqa: E501

        :param principal_type: The principal_type of this RoleAssignment.  # noqa: E501
        :type: str
        """

        self._principal_type = principal_type

    @property
    def project_id(self):
        """Gets the project_id of this RoleAssignment.  # noqa: E501

        The id of the project this role assignment is applicable for  # noqa: E501

        :return: The project_id of this RoleAssignment.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this RoleAssignment.

        The id of the project this role assignment is applicable for  # noqa: E501

        :param project_id: The project_id of this RoleAssignment.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def role_id(self):
        """Gets the role_id of this RoleAssignment.  # noqa: E501

        Id of the role that is assigned.  # noqa: E501

        :return: The role_id of this RoleAssignment.  # noqa: E501
        :rtype: str
        """
        return self._role_id

    @role_id.setter
    def role_id(self, role_id):
        """Sets the role_id of this RoleAssignment.

        Id of the role that is assigned.  # noqa: E501

        :param role_id: The role_id of this RoleAssignment.  # noqa: E501
        :type: str
        """
        if role_id is None:
            raise ValueError("Invalid value for `role_id`, must not be `None`")  # noqa: E501

        self._role_id = role_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RoleAssignment, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleAssignment):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
